/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2009 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

#ifndef CONFIGURATION_MANAGER_H
#define CONFIGURATION_MANAGER_H

#include <string>
#include <iostream>

#include "toppers/oil/oil_parser.hpp"
#include "toppers/text.hpp"
#include "toppers/diagnostics.hpp"

using namespace toppers::oil;

namespace toppers
{
	namespace configuration_manager
	{

		class config_manage
		{
			public:
				config_manage(void)
				{
				}
				~config_manage()
				{
					delete description_str;
					delete parser;
				}
				bool read_configuration
					(toppers::text *txt , std::vector<std::string> const& objlist);
				void dump_configuration(void)
				{
					parser->dump_implementation();
					parser->dump_definition();
				}

				::oil_def* const get_obj_def(void)
				{
					return oil_def;
				}
				bool validate_and_assign_default_configuration(void);
			private:
				bool validate_object_reference
						(std::string obj_name , std::vector<object_ref> *obj_refs);
				toppers::text *description;
				string *description_str;
				oil_parser *parser;
				::oil_def *oil_def;
				::oil_impl *oil_impl;
		};

	}	/* namespace configuration_manager */

}	/* namespace toppers */

#endif	/* CONFIGURATION_MANAGER_H */
